## libqtxdg 4.0.0

=== debian/changelog ===
libqtxdg (4.0.0-2~exp1) experimental; urgency=medium

  * debian/control: build-deps on qt6-base-private-dev (>= 6.7.2).
  * debian/control: build-deps on qt6-tools-dev.
  * debian/control: build-deps on qt6-tools-dev-tools.
  * debian/control: recommends on qt6-translations-l10n.
  * debian/control: bump to Standards-version to 4.7.0, no changes needed.
  * debian/salsa-ci.yml: build against to experimental.

 -- Andrew Lee (李健秋) <ajqlee@debian.org>  Sun, 06 Oct 2024 12:17:43 +0200

libqtxdg (4.0.0-1) experimental; urgency=medium

  * New upstream version 4.0.0
  * Clean up of group membership after 2nd calls.
  * debian/control: build-deps on pkgconf,
  * debian/control: build-deps on lxqt-build-tools (>= 2.0.0~).
  * debian/control: build-deps on qt6-base-private-dev (>= 6.6.0~).
  * debian/control: build-deps on qt6-svg-dev.
  * debian/control: build-deps on libglib2.0-dev.
  * Bump libqt5xdg3 to libqt6xdg4.
  * Bump libqt5xdgiconloader3 to libqt6xdgiconloader4.
  * Bump libqt5xdg-dev to libqt6xdg-dev.
  * Bump libqt5xdgiconloader-dev to libqt6xdgiconloader-dev.
  * debian/control: update depends for libqt6xdgiconloader-dev and qtxdg-
    dev-tools.
  * Run wrap-and-sort.
  * debian/control: libqt6xdg4 conflicts on libqt5xdg3.
  * debian/copyright: drop upstream deleted file.
  * debian/salsa-ci.yml: build against to experimental.
  * debian/salsa-ci.yml: disable i386 build tests due to a qt6 bug.
  * debian/control: build-deps on lxqt-build-tools (>= 2.0.0+really2.0.0~).
  * debian/copyright: update.

 -- Andrew Lee (李健秋) <ajqlee@debian.org>  Fri, 02 Aug 2024 07:22:53 +0200

=== debian/control ===
Source: libqtxdg
Maintainer: LXQt Packaging Team <team+lxqt@tracker.debian.org>
Uploaders: ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
           Andrew Lee (李健秋) <ajqlee@debian.org>
Section: libs
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               libglib2.0-dev,
               libmagic-dev,
               lxqt-build-tools (>= 2.0.0+really2.0.0~),
               pkgconf,
               qt6-base-private-dev (>= 6.7.2),
               qt6-svg-dev,
               qt6-tools-dev,
               qt6-tools-dev-tools
Standards-Version: 4.7.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/lxqt-team/libqtxdg
Vcs-Git: https://salsa.debian.org/lxqt-team/libqtxdg.git
Homepage: https://github.com/lxqt/libqtxdg

Package: libqt6xdg4
Architecture: any
Multi-Arch: same
Depends: file,
         libfile-mimeinfo-perl,
         libglib2.0-bin,
         shared-mime-info,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: qt6-translations-l10n
Pre-Depends: ${misc:Pre-Depends}
Provides: libqt6xdg
Conflicts: libqt5xdg3
Description: Implementation of the XDG Specifications for Qt (shared lib)
 This library implements functions of the XDG Specifications in Qt.  It is part
 of LXQt.
 .
 This package provides the shared library.

Package: libqt6xdgiconloader4
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: gtk-update-icon-cache
Pre-Depends: ${misc:Pre-Depends}
Provides: libqt6xdgiconloader
Description: Implementation of the XDG Iconloader for Qt (shared lib)
 This library implements the backend to load icons which are handled according
 to the XDG Icon Theme Specification in Qt. It is part of LXQt.
 .
 This package provides the shared library.

Package: libqt6xdg-dev
Architecture: any
Section: libdevel
Depends: libmagic-dev,
         libqt6xdg4 (= ${binary:Version}),
         libqt6xdgiconloader-dev (= ${binary:Version}),
         ${misc:Depends}
Recommends: qtxdg-dev-tools (= ${source:Version})
Description: Development files for libqtxdg
 This library implements functions of the XDG Specifications in Qt. It is part
 of LXQt.
 .
 This package provides development files.

Package: libqt6xdgiconloader-dev
Architecture: any
Section: libdevel
Depends: libqt6xdgiconloader4 (= ${binary:Version}),
         qt6-svg-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Development files for libqtxdgiconloader
 This library implements the backend to load icons which are handled according
 to the XDG Icon Theme Specification in Qt. It is part of LXQt.
 .
 This package provides development files.

Package: qtxdg-dev-tools
Architecture: any
Section: devel
Depends: libqt6xdg4 (= ${binary:Version}),
         libqt6xdgiconloader4 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Tools for QtXdg
 This package provide some tools for qtxdg:
 .
  * qtxdg-desktop-file-start - QtXdg XdgDesktopFile start Tester
  * qtxdg-iconfinder - Find icons the QtXdg way
  * qtxdg-mat - Mime app tool for QtXdg

## libqtxdg 4.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18.0 FATAL_ERROR)
# CMP0000: Call the cmake_minimum_required() command at the beginning of the top-level
# CMakeLists.txt file even before calling the project() command.
# The cmake_minimum_required(VERSION) command implicitly invokes the cmake_policy(VERSION)
# command to specify that the current project code is written for the given range of CMake
# versions.
project(libqtxdg)

option(BUILD_TESTS "Builds tests" OFF)
option(BUILD_DEV_UTILS "Builds and install development utils" OFF)
option(QTXDG_INSTALL_DEFAPPS_CONFIG "Install default app config files" ON)

# additional cmake files
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

set(QTXDG_MAJOR_VERSION 4)
set(QTXDG_MINOR_VERSION 1)
set(QTXDG_PATCH_VERSION 0)
set(QTXDG_VERSION_STRING ${QTXDG_MAJOR_VERSION}.${QTXDG_MINOR_VERSION}.${QTXDG_PATCH_VERSION})

set(LXQTBT_MINIMUM_VERSION "2.1.0")
set(QT_MINIMUM_VERSION "6.6.0")
set(GLIB_MINIMUM_VERSION "2.41.0") # Mime Apps new implementation

find_package(lxqt2-build-tools ${LXQTBT_MINIMUM_VERSION} REQUIRED)
find_package(Qt6 ${QT_MINIMUM_VERSION} CONFIG REQUIRED Widgets Svg Xml DBus)
find_package(GLIB ${GLIB_MINIMUM_VERSION} REQUIRED COMPONENTS gobject gio gio-unix)
find_package(XTerm)

include(GNUInstallDirs)             # Standard directories for installation
include(CMakePackageConfigHelpers)
include(GenerateExportHeader)

include(LXQtConfigVars)
include(LXQtPreventInSourceBuilds)
include(LXQtCreatePkgConfigFile)
include(LXQtCreatePortableHeaders)
include(LXQtCompilerSettings NO_POLICY_SCOPE)

# Add link optimizations. It make the .so around 33% smaller without any known
# drawback.
include(compiler_settings NO_POLICY_SCOPE)

set(CMAKE_AUTOMOC ON)

if (BUILD_TESTS)
    find_package(Qt6 ${QT_MINIMUM_VERSION} CONFIG REQUIRED Test)
endif()


set(QTXDGX_LIBRARY_NAME "Qt6Xdg")
set(QTXDGX_FILE_NAME "qt6xdg")

set(QTXDGX_ICONLOADER_LIBRARY_NAME "Qt6XdgIconLoader")
set(QTXDGX_ICONLOADER_FILE_NAME "qt6xdgiconloader")
set(QTXDGX_ICONENGINEPLUGIN_LIBRARY_NAME "Qt6XdgIconPlugin")

set(QTXDGX_PKG_CONFIG_DESCRIPTION "Qt6Xdg, a Qt6 implementation of XDG standards")
set(QTXDGX_PKG_CONFIG_REQUIRES "Qt6Core >= ${QT_MINIMUM_VERSION}, Qt6Xml >= ${QT_MINIMUM_VERSION}, Qt6Widgets >= ${QT_MINIMUM_VERSION}, Qt6DBus >= ${QT_MINIMUM_VERSION}, Qt6XdgIconLoader = ${QTXDG_VERSION_STRING}")

set(QTXDGX_ICONLOADER_PKG_CONFIG_DESCRIPTION "Qt6XdgIconLader, a Qt6 XDG Icon Loader")
set(QTXDGX_ICONLOADER_PKG_CONFIG_REQUIRES "Qt6Gui >= ${QT_MINIMUM_VERSION}, Qt6Svg >= ${QT_MINIMUM_VERSION}")

set(QTXDGX_INTREE_INCLUDEDIR "${CMAKE_CURRENT_BINARY_DIR}/InTreeBuild/include")

message(STATUS "Building ${PROJECT_NAME} with Qt ${Qt6Core_VERSION}")

if (QTXDG_INSTALL_DEFAPPS_CONFIG)
    file(GLOB QTXDG_CONFIG_FILES config/*.conf)
    set(QTXDG_DEFAPPS_CONF_INSTALL_DIR
        "${LXQT_ETC_XDG_DIR}" CACHE PATH "Path to qtxdg default apps conf files install dir")
    mark_as_advanced(QTXDG_DEFAPPS_CONF_INSTALL_DIR)
endif()


add_subdirectory(src)

if(BUILD_TESTS)
    enable_testing()
    target_compile_definitions(${QTXDGX_LIBRARY_NAME}
        PRIVATE "QTXDG_TESTS=\"1\""
    )
    add_subdirectory(test)
else()
    message(STATUS "")
    message(STATUS "For building tests use -DBUILD_TESTS=Yes option.")
    message(STATUS "")
endif()

if (BUILD_DEV_UTILS)
    add_subdirectory(util)
endif()

configure_package_config_file(
    "${PROJECT_SOURCE_DIR}/cmake/${QTXDGX_FILE_NAME}-config.cmake.in"
    "${CMAKE_BINARY_DIR}/${QTXDGX_FILE_NAME}-config.cmake"
    INSTALL_DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${QTXDGX_FILE_NAME}"
)

write_basic_package_version_file(
    "${CMAKE_BINARY_DIR}/${QTXDGX_FILE_NAME}-config-version.cmake"
    VERSION ${QTXDG_VERSION_STRING}
    COMPATIBILITY AnyNewerVersion
)

configure_package_config_file(
    "${PROJECT_SOURCE_DIR}/cmake/${QTXDGX_ICONLOADER_FILE_NAME}-config.cmake.in"
    "${CMAKE_BINARY_DIR}/${QTXDGX_ICONLOADER_FILE_NAME}-config.cmake"
    INSTALL_DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${QTXDGX_ICONLOADER_FILE_NAME}"
)

write_basic_package_version_file(
    "${CMAKE_BINARY_DIR}/${QTXDGX_ICONLOADER_FILE_NAME}-config-version.cmake"
    VERSION ${QTXDG_VERSION_STRING}
    COMPATIBILITY AnyNewerVersion
)

lxqt_create_pkgconfig_file(
    PACKAGE_NAME ${QTXDGX_LIBRARY_NAME}
    DESCRIPTIVE_NAME ${QTXDGX_LIBRARY_NAME}
    DESCRIPTION ${QTXDGX_PKG_CONFIG_DESCRIPTION}
    INCLUDEDIRS ${QTXDGX_FILE_NAME}
    LIBS ${QTXDGX_LIBRARY_NAME}
    REQUIRES ${QTXDGX_PKG_CONFIG_REQUIRES}
    REQUIRES_PRIVATE ${QTXDGX_ICONLOADER_LIBRARY_NAME}
    VERSION ${QTXDG_VERSION_STRING}
    INSTALL
)

lxqt_create_pkgconfig_file(
    PACKAGE_NAME ${QTXDGX_ICONLOADER_LIBRARY_NAME}
    DESCRIPTIVE_NAME ${QTXDGX_ICONLOADER_LIBRARY_NAME}
    DESCRIPTION ${QTXDGX_ICONLOADER_PKG_CONFIG_DESCRIPTION}
    INCLUDEDIRS ${QTXDGX_ICONLOADER_FILE_NAME}
    LIBS ${QTXDGX_ICONLOADER_LIBRARY_NAME}
    REQUIRES ${QTXDGX_ICONLOADER_PKG_CONFIG_REQUIRES}
    VERSION ${QTXDG_VERSION_STRING}
    INSTALL
)

install(FILES
    "${CMAKE_BINARY_DIR}/${QTXDGX_FILE_NAME}-config.cmake"
    "${CMAKE_BINARY_DIR}/${QTXDGX_FILE_NAME}-config-version.cmake"
    DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${QTXDGX_FILE_NAME}"
    COMPONENT Devel
)

install(FILES
    "${CMAKE_BINARY_DIR}/${QTXDGX_ICONLOADER_FILE_NAME}-config.cmake"
    "${CMAKE_BINARY_DIR}/${QTXDGX_ICONLOADER_FILE_NAME}-config-version.cmake"
    DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${QTXDGX_ICONLOADER_FILE_NAME}"
    COMPONENT Devel
)

install(EXPORT
    "${QTXDGX_FILE_NAME}-targets"
    DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${QTXDGX_FILE_NAME}"
    FILE "${QTXDGX_FILE_NAME}-targets.cmake"
    COMPONENT Devel
)

install(EXPORT
    "${QTXDGX_ICONLOADER_FILE_NAME}-targets"
    DESTINATION "${CMAKE_INSTALL_DATADIR}/cmake/${QTXDGX_ICONLOADER_FILE_NAME}"
    FILE "${QTXDGX_ICONLOADER_FILE_NAME}-targets.cmake"
    COMPONENT Devel
)

if (QTXDG_INSTALL_DEFAPPS_CONFIG)
    install(FILES ${QTXDG_CONFIG_FILES}
        DESTINATION "${QTXDG_DEFAPPS_CONF_INSTALL_DIR}"
        COMPONENT Runtime
    )
endif()

# uninstall target
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

#add_custom_target(uninstall
#    COMMAND ${CMAKE_COMMAND} -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== test/CMakeLists.txt ===
remove_definitions(
    -DQT_USE_QSTRINGBUILDER
    -DQT_NO_CAST_FROM_ASCII
)

add_definitions(
    -DQT_NO_KEYWORDS
)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

macro(qtxdg_add_test)
    foreach(_testname ${ARGN})
        add_executable(${_testname} ${_testname}.cpp)
        target_link_libraries(${_testname} Qt6::Test ${QTXDGX_LIBRARY_NAME})
        target_include_directories(${_testname}
            PRIVATE "${PROJECT_SOURCE_DIR}/src/qtxdg"
        )
        add_test(NAME ${_testname} COMMAND ${_testname})
    endforeach()
endmacro()

set_property(DIRECTORY APPEND
    PROPERTY COMPILE_DEFINITIONS "QTXDG_BUILDING_TESTS=\"1\""
)

qtxdg_add_test(
    qtxdg_test
    tst_xdgdirs
    tst_xdgdesktopfile
)

=== examples/use-qtxdg/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0 FATAL_ERROR)
# CMP0000: Call the cmake_minimum_required() command at the beginning of the top-level
# CMakeLists.txt file even before calling the project() command.
# The cmake_minimum_required(VERSION) command implicitly invokes the cmake_policy(VERSION)
# command to specify that the current project code is written for the given range of CMake
# versions.
project(use-qtxdg)

find_package(QT6XDG)
add_executable(use-qtxdg main.cpp)
target_link_libraries(use-qtxdg Qt6Xdg)

=== debian/changelog ===
libqtxdg (4.1.0-1) unstable; urgency=medium

  * New upstream version 4.1.0

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Tue, 03 Dec 2024 22:06:49 +0800

libqtxdg (4.0.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Andrew Lee (李健秋) <ajqlee@debian.org>  Wed, 27 Nov 2024 18:22:24 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                debhelper-compat (= 13),
                libglib2.0-dev,
                libmagic-dev,
-               lxqt-build-tools (>= 2.0.0+really2.0.0~),
+               lxqt-build-tools (>= 2.1.0~),
                pkgconf,
                qt6-base-private-dev (>= 6.7.2),
                qt6-svg-dev,

## libqtxdg 4.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,11 +14,11 @@
 set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
 set(QTXDG_MAJOR_VERSION 4)
-set(QTXDG_MINOR_VERSION 1)
+set(QTXDG_MINOR_VERSION 2)
 set(QTXDG_PATCH_VERSION 0)
 set(QTXDG_VERSION_STRING ${QTXDG_MAJOR_VERSION}.${QTXDG_MINOR_VERSION}.${QTXDG_PATCH_VERSION})
 
-set(LXQTBT_MINIMUM_VERSION "2.1.0")
+set(LXQTBT_MINIMUM_VERSION "2.2.0")
 set(QT_MINIMUM_VERSION "6.6.0")
 set(GLIB_MINIMUM_VERSION "2.41.0") # Mime Apps new implementation

=== src/CMakeLists.txt ===
add_subdirectory(xdgiconloader)
add_subdirectory(qtxdg)

=== util/CMakeLists.txt ===
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(QTXDG_DESKTOP_FILE_START_SRCS
    qtxdg-desktop-file-start.cpp
)

set(QTXDG_ICONFINDER_SRCS
    qtxdg-iconfinder.cpp
)

add_executable(qtxdg-desktop-file-start
    ${QTXDG_DESKTOP_FILE_START_SRCS}
)

add_executable(qtxdg-iconfinder
    ${QTXDG_ICONFINDER_SRCS}
)

target_include_directories(qtxdg-desktop-file-start
    PRIVATE "${PROJECT_SOURCE_DIR}/qtxdg"
)

target_include_directories(qtxdg-iconfinder
    PRIVATE "${Qt6Gui_PRIVATE_INCLUDE_DIRS}"
)

target_compile_definitions(qtxdg-desktop-file-start
    PRIVATE
        "-DQTXDG_VERSION=\"${QTXDG_VERSION_STRING}\""
        "QT_NO_KEYWORDS"
)

target_compile_definitions(qtxdg-iconfinder
    PRIVATE
        "-DQTXDG_VERSION=\"${QTXDG_VERSION_STRING}\""
        "QT_NO_KEYWORDS"
)

target_link_libraries(qtxdg-desktop-file-start
    ${QTXDGX_LIBRARY_NAME}
)

target_link_libraries(qtxdg-iconfinder
    ${QTXDGX_ICONLOADER_LIBRARY_NAME}
)

install(TARGETS
    qtxdg-desktop-file-start
    qtxdg-iconfinder
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
    COMPONENT Runtime
)

=== src/qtxdg/CMakeLists.txt ===
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(QTX_LIBRARIES Qt6::Widgets Qt6::Xml Qt6::DBus)

set(libqtxdg_PUBLIC_H_FILES
    xdgaction.h
    xdgdesktopfile.h
    xdgdirs.h
    xdgicon.h
    xdgmenu.h
    xdgmenuwidget.h
    xmlhelper.h
    xdgautostart.h
    xdgmacros.h
    xdgmimetype.h
    xdgmimeapps.h
    xdgdefaultapps.h
)

set(libqtxdg_PUBLIC_CLASSES
    XdgAction
    XdgDesktopFile
    XdgDirs
    XdgIcon
    XdgMenu
    XdgMenuWidget
    XmlHelper
    XdgAutoStart
    XdgMimeType
    XdgMimeApps
    XdgDefaultApps
)

set(libqtxdg_PRIVATE_H_FILES
    qtxdglogging.h
    xdgmenuapplinkprocessor.h
    xdgmenulayoutprocessor.h
    xdgmenu_p.h
    xdgmenureader.h
    xdgmenurules.h
    xdgdesktopfile_p.h
    xdgmimeapps_p.h
)

set(libqtxdg_CPP_FILES
    qtxdglogging.cpp
    xdgaction.cpp
    xdgdesktopfile.cpp
    xdgdirs.cpp
    xdgicon.cpp
    xdgmenuapplinkprocessor.cpp
    xdgmenu.cpp
    xdgmenulayoutprocessor.cpp
    xdgmenureader.cpp
    xdgmenurules.cpp
    xdgmenuwidget.cpp
    xmlhelper.cpp
    xdgautostart.cpp
    xdgmimetype.cpp
    xdgmimeapps.cpp
    xdgmimeappsbackendinterface.cpp
    xdgmimeappsglibbackend.cpp
    xdgdefaultapps.cpp
)

QT6_ADD_DBUS_INTERFACE(libqtxdg_DBUS_INTERFACE_SRCS
    dbus/org.freedesktop.Application.xml
    application_interface
)

set_property(SOURCE ${libqtxdg_DBUS_INTERFACE_SRCS} PROPERTY SKIP_AUTOGEN ON)

add_library(${QTXDGX_LIBRARY_NAME} SHARED
    ${libqtxdg_PUBLIC_H_FILES}
    ${libqtxdg_PRIVATE_H_FILES}
    ${libqtxdg_CPP_FILES}
    ${libqtxdg_DBUS_INTERFACE_SRCS}
)

target_link_libraries(${QTXDGX_LIBRARY_NAME}
    PUBLIC
        ${QTX_LIBRARIES}
        ${QTXDGX_ICONLOADER_LIBRARY_NAME}
        ${GLIB_LIBRARIES}
        ${GLIB_GOBJECT_LIBRARIES}
        ${GLIB_GIO_LIBRARIES}
)

set_target_properties(${QTXDGX_LIBRARY_NAME} PROPERTIES
  VERSION ${QTXDG_VERSION_STRING}
  SOVERSION ${QTXDG_MAJOR_VERSION}
)

target_compile_definitions(${QTXDGX_LIBRARY_NAME}
    PRIVATE
        "QTXDG_COMPILATION=\"1\""
        "QTXDG_VERSION=\"${QTXDG_VERSION_STRING}\""
        "QT_NO_KEYWORDS"
)

target_include_directories(${QTXDGX_LIBRARY_NAME}
    INTERFACE
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${QTXDGX_FILE_NAME}>"
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
        "$<BUILD_INTERFACE:${QTXDGX_INTREE_INCLUDEDIR}/${QTXDGX_FILE_NAME}>"
        "$<BUILD_INTERFACE:${QTXDGX_INTREE_INCLUDEDIR}>"
    PRIVATE
        ${Qt6Gui_PRIVATE_INCLUDE_DIRS}
        ${GLIB_INCLUDE_DIRS}
        ${GLIB_GIO_UNIX_INCLUDE_DIR}
)

# create the portble headers
lxqt_create_portable_headers(libqtxdg_PORTABLE_HEADERS
    HEADER_NAMES ${libqtxdg_PUBLIC_CLASSES}
    OUTPUT_DIR "${QTXDGX_INTREE_INCLUDEDIR}/${QTXDGX_FILE_NAME}"
)

# Copy public headers (in tree building)
foreach(h ${libqtxdg_PUBLIC_H_FILES})
    get_filename_component(bh ${h} NAME)
    configure_file(${h} "${QTXDGX_INTREE_INCLUDEDIR}/${QTXDGX_FILE_NAME}/${bh}" COPYONLY)
endforeach()

# Copy private headers (in tree building)
foreach(h ${libqtxdg_PRIVATE_INSTALLABLE_H_FILES})
    get_filename_component(bh ${h} NAME)
    configure_file(${h} "${QTXDGX_INTREE_INCLUDEDIR}/${QTXDGX_FILE_NAME}/${QTXDG_VERSION_STRING}/private/qtxdg/${bh}" COPYONLY)
endforeach()

install(TARGETS
    ${QTXDGX_LIBRARY_NAME} DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    EXPORT "${QTXDGX_FILE_NAME}-targets"
    COMPONENT Runtime
)

install(FILES
    ${libqtxdg_PUBLIC_H_FILES}
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${QTXDGX_FILE_NAME}"
    COMPONENT Devel
)

install(FILES
    ${libqtxdg_PRIVATE_INSTALLABLE_H_FILES}
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${QTXDGX_FILE_NAME}/${QTXDG_VERSION_STRING}/private/qtxdg"
    COMPONENT Devel
)

install(FILES
    ${libqtxdg_PORTABLE_HEADERS}
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${QTXDGX_FILE_NAME}"
    COMPONENT Devel
)

=== src/xdgiconloader/CMakeLists.txt ===
set(xdgiconloader_PUBLIC_H_FILES
)

set(xdgiconloader_PUBLIC_CLASSES
)

set(xdgiconloader_PRIVATE_H_FILES
)

set(xdgiconloader_CPP_FILES
    xdgiconloader.cpp
)

set(xdgiconloader_PRIVATE_INSTALLABLE_H_FILES
    xdgiconloader_p.h
)


add_library(${QTXDGX_ICONLOADER_LIBRARY_NAME} SHARED
    ${xdgiconloader_CPP_FILES}
    ${xdgiconloader_PRIVATE_INSTALLABLE_H_FILES}
)

generate_export_header(${QTXDGX_ICONLOADER_LIBRARY_NAME} BASE_NAME XdgIconLoader)

# Copy public headers (in tree building)
set(XDGICONLOADER_EXPORT_FILE "xdgiconloader_export.h")
configure_file(
    "${CMAKE_CURRENT_BINARY_DIR}/${XDGICONLOADER_EXPORT_FILE}"
    "${QTXDGX_INTREE_INCLUDEDIR}/${QTXDGX_ICONLOADER_FILE_NAME}/${XDGICONLOADER_EXPORT_FILE}"
    COPYONLY
)

target_compile_definitions(${QTXDGX_ICONLOADER_LIBRARY_NAME}
    PRIVATE
        "QT_NO_KEYWORDS"
)

target_include_directories(${QTXDGX_ICONLOADER_LIBRARY_NAME}
    INTERFACE
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${QTXDGX_ICONLOADER_FILE_NAME}>"
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${QTXDGX_ICONLOADER_FILE_NAME}/${QTXDG_VERSION_STRING}>"
    PUBLIC
        "$<BUILD_INTERFACE:${QTXDGX_INTREE_INCLUDEDIR}/${QTXDGX_ICONLOADER_FILE_NAME}>"
        "$<BUILD_INTERFACE:${QTXDGX_INTREE_INCLUDEDIR}>"
        "$<BUILD_INTERFACE:${QTXDGX_INTREE_INCLUDEDIR}/${QTXDGX_ICONLOADER_FILE_NAME}/${QTXDG_VERSION_STRING}>"
    PRIVATE
        ${Qt6Gui_PRIVATE_INCLUDE_DIRS}
)

target_link_libraries(${QTXDGX_ICONLOADER_LIBRARY_NAME}
    PUBLIC
        Qt6::Gui
        Qt6::Svg
)

set_target_properties(${QTXDGX_ICONLOADER_LIBRARY_NAME}
    PROPERTIES
        VERSION   ${QTXDG_VERSION_STRING}
        SOVERSION ${QTXDG_MAJOR_VERSION}
)

add_subdirectory(plugin)

install(TARGETS
    ${QTXDGX_ICONLOADER_LIBRARY_NAME} DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    EXPORT "${QTXDGX_ICONLOADER_FILE_NAME}-targets"
    COMPONENT Runtime
)

install(FILES
    ${xdgiconloader_PRIVATE_INSTALLABLE_H_FILES}
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${QTXDGX_ICONLOADER_FILE_NAME}/${QTXDG_VERSION_STRING}/private/xdgiconloader"
    COMPONENT Devel
)

file(COPY
    ${xdgiconloader_PRIVATE_INSTALLABLE_H_FILES}
    DESTINATION "${QTXDGX_INTREE_INCLUDEDIR}/${QTXDGX_ICONLOADER_FILE_NAME}/${QTXDG_VERSION_STRING}/private/xdgiconloader"
)

install(FILES
    "${QTXDGX_INTREE_INCLUDEDIR}/${QTXDGX_ICONLOADER_FILE_NAME}/${XDGICONLOADER_EXPORT_FILE}"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${QTXDGX_ICONLOADER_FILE_NAME}"
)

=== src/xdgiconloader/plugin/CMakeLists.txt ===
set(xdgiconengineplugin_CPP_FILES
    xdgiconengineplugin.cpp
)

add_library(${QTXDGX_ICONENGINEPLUGIN_LIBRARY_NAME} MODULE
    ${xdgiconengineplugin_CPP_FILES}
)

target_compile_definitions(${QTXDGX_ICONENGINEPLUGIN_LIBRARY_NAME}
    PRIVATE
        "QT_NO_KEYWORDS"
)
target_link_libraries(${QTXDGX_ICONENGINEPLUGIN_LIBRARY_NAME}
    PUBLIC
        Qt6::Gui
        "${QTXDGX_ICONLOADER_LIBRARY_NAME}"
)

target_include_directories("${QTXDGX_ICONENGINEPLUGIN_LIBRARY_NAME}"
    PRIVATE
        "${Qt6Gui_PRIVATE_INCLUDE_DIRS}"
)

mark_as_advanced(QTXDGX_ICONENGINEPLUGIN_INSTALL_PATH)

if (NOT DEFINED QTXDGX_ICONENGINEPLUGIN_INSTALL_PATH)
    include(LXQtQueryQt)
    lxqt_query_qt(_QT_PLUGINS_DIR QT_INSTALL_PLUGINS)

    if (NOT _QT_PLUGINS_DIR)
        message(FATAL_ERROR "Qt6 plugin directory cannot be detected.")
    endif()
    set(QTXDGX_ICONENGINEPLUGIN_INSTALL_PATH "${_QT_PLUGINS_DIR}/iconengines")
endif()

message(STATUS "XdgIconEnginePlugin will be installed into: ${QTXDGX_ICONENGINEPLUGIN_INSTALL_PATH}")

install(TARGETS
    "${QTXDGX_ICONENGINEPLUGIN_LIBRARY_NAME}" DESTINATION "${QTXDGX_ICONENGINEPLUGIN_INSTALL_PATH}"
    COMPONENT Runtime
)

=== debian/changelog ===
libqtxdg (4.2.0-1) unstable; urgency=medium

  * Merge to unstable.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Mon, 11 Aug 2025 21:15:57 +0800

libqtxdg (4.2.0-1~exp1) experimental; urgency=medium

  * New upstream version 4.2.0.
  * debian/control: Bumped the version of lxqt-build-tools.
  * debian/libqt6xdg4.shlibs: Bumped the version of libqt6xdg4 to 4.2.0.
  * debian/copyright: Added myself.
  * debian/control: Added myslelf as uploader.

 -- Joel Orón Valiente <moded3v@gmail.com>  Sat, 12 Jul 2025 16:42:53 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,15 @@
 Source: libqtxdg
 Maintainer: LXQt Packaging Team <team+lxqt@tracker.debian.org>
 Uploaders: ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
-           Andrew Lee (李健秋) <ajqlee@debian.org>
+           Andrew Lee (李健秋) <ajqlee@debian.org>,
+           Joel Orón Valiente <moded3v@gmail.com>
 Section: libs
 Priority: optional
 Build-Depends: cmake,
                debhelper-compat (= 13),
                libglib2.0-dev,
                libmagic-dev,
-               lxqt-build-tools (>= 2.1.0~),
+               lxqt-build-tools (>= 2.2.0~),
                pkgconf,
                qt6-base-private-dev (>= 6.7.2),
                qt6-svg-dev,

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export LC_ALL=C.UTF-8
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto


%:
	dh ${@} --buildsystem cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_DEV_UTILS=YES \
		-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo

execute_before_dh_auto_build:
	@echo "blhc: ignore-line-regexp: .*/CMakeCXXCompilerABI[.]cpp.*"

=== debian/watch ===
version=4
opts="downloadurlmangle=s%/tag/([^/]+)$%/download/$1/@PACKAGE@-$1.tar.xz%, filenamemangle=s%^.*/([^/]+)$%@PACKAGE@-$1.tar.xz%, pgpsigurlmangle=s/$/.asc/" \
  https://github.com/lxqt/@PACKAGE@/tags /lxqt/@PACKAGE@/releases/tag/([^/]+)$

## libqtxdg 4.3.0

=== src/xdgiconloader/CMakeLists.txt ===
--- 
+++ 
@@ -50,6 +50,8 @@
 )
 
 target_link_libraries(${QTXDGX_ICONLOADER_LIBRARY_NAME}
+    PRIVATE
+        Qt6::GuiPrivate
     PUBLIC
         Qt6::Gui
         Qt6::Svg

=== debian/changelog ===
libqtxdg (4.3.0-2) unstable; urgency=medium

  * debian/libqt6xdg4.shlibs: update.
  * debian/libqt6xdgiconloader4.shlibs: update.
  * Run wrap-and-sort.
  * debian/copyright: update.

 -- Andrew Lee (李健秋) <ajqlee@debian.org>  Sat, 22 Nov 2025 10:48:25 +0100

libqtxdg (4.3.0-1) unstable; urgency=medium

  * New upstream version 4.3.0.
  * d/control: Update Build-Depends.
  * d/control: Bump Standards-Version to 4.7.2.
  * d/watch: Upgrade to version 5.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Tue, 11 Nov 2025 08:08:50 +0800

=== debian/control ===
--- 
+++ 
@@ -5,17 +5,17 @@
            Joel Orón Valiente <moded3v@gmail.com>
 Section: libs
 Priority: optional
-Build-Depends: cmake,
-               debhelper-compat (= 13),
+Build-Depends: debhelper-compat (= 13),
+               cmake,
                libglib2.0-dev,
                libmagic-dev,
-               lxqt-build-tools (>= 2.2.0~),
+               lxqt-build-tools (>= 2.3.0~),
                pkgconf,
                qt6-base-private-dev (>= 6.7.2),
                qt6-svg-dev,
                qt6-tools-dev,
                qt6-tools-dev-tools
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/lxqt-team/libqtxdg
 Vcs-Git: https://salsa.debian.org/lxqt-team/libqtxdg.git
